# NOTE: Derived from blib/lib/Inline.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Inline;

#line 407 "blib/lib/Inline.pm (autosplit into blib/lib/auto/Inline/parse_C.al)"
#==============================================================================
# Parse the function definition information out of the C code
#==============================================================================
my $C_grammar = <<'END_OF_GRAMMAR';

c_code:	part(s) {1}

part:	  comment
	| function_definition
	{
	 my $function = $item[1]->[0];
	 push @{$thisparser->{data}->{functions}}, $function;
	 $thisparser->{data}->{function}->{$function}->{return_type} = 
             $item[1]->[1];
	 $thisparser->{data}->{function}->{$function}->{arg_types} = 
             [map {ref $_ ? $_->[0] : '...'} @{$item[1]->[2]}];
	 $thisparser->{data}->{function}->{$function}->{arg_names} = 
             [map {ref $_ ? $_->[1] : '...'} @{$item[1]->[2]}];
	}
	| anything_else

comment:  m{\s* // [^\n]* \n }x
	| m{\s* /\* (?:[^*]+|\*(?!/))* \*/  ([ \t]*)? }x

function_definition:
	type IDENTIFIER '(' <leftop: arg ',' arg>(s?) ')' '{'
	{[@item[2,1], $item[4]]}

type:	('SV' | 'int' | 'long' | 'double' | 'char' | 'void') star(s?)
	{
         $return = join '',$item[1],@{$item[2]};
         $return = '' unless ($Inline::valid_types{$return});
	}

star: '*'

arg:	  type IDENTIFIER {[@item[1,2]]}
	| '...'

IDENTIFIER: /[a-z]\w*/i

anything_else: /.*/

END_OF_GRAMMAR

sub parse_C {
    use strict;
    use Data::Dumper;
    use Parse::RecDescent;

    my $o = shift;
    return if $o->{parser};

    %Inline::valid_types = map {($_, 1)}
    qw(SV* int long double char* void);

    $::RD_HINT++;
    my $parser = $o->{parser} = Parse::RecDescent->new($C_grammar);

    $parser->c_code($o->{code})
      or croak "Bad C code passed to Inline at @{[caller(2)]}\n";
#    print STDERR Data::Dumper::Dumper $parser->{data};
}

# end of Inline::parse_C
1;
