# NOTE: Derived from blib/lib/Inline.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Inline;

#line 303 "blib/lib/Inline.pm (autosplit into blib/lib/auto/Inline/print_info.al)"
#==============================================================================
# Print a small report if PRINT_INFO option is set.
#==============================================================================
sub print_info {
    use strict;
    my $o = shift;

    print STDERR <<END;
<-----------------------Information Section----------------------------------->

Information about the processing of your Inline $o->{language} code:

END
    
    print STDERR <<END if ($o->{mod_exists});
Your module is already compiled. It is located at:
$o->{location}

END

    print STDERR <<END if ($o->{mod_exists} and $Inline::Config::FORCE_BUILD);
But the FORCE_BUILD option is set, so your code will be recompiled.
I\'ll use this build directory:
$o->{build_dir}

and I\'ll install the executable as:
$o->{location}

END
    print STDERR <<END if (not $o->{mod_exists});
Your source code needs to be compiled. I\'ll use this build directory:
$o->{build_dir}

and I\'ll install the executable as:
$o->{location}

END

    $o->parse_C unless $o->{parser};
    if (@{$o->{parser}->{data}->{functions}}) {
	print STDERR "The following Inline $o->{language} function(s) have been successfully bound to Perl:\n";
	my $parser = $o->{parser};
	my $data = $parser->{data};
	for my $function (sort @{$data->{functions}}) {
	    my $return_type = $data->{function}->{$function}->{return_type};
	    my @arg_names = @{$data->{function}->{$function}->{arg_names}};
	    my @arg_types = @{$data->{function}->{$function}->{arg_types}};
	    my @args = map {$_ . ' ' . shift @arg_names} @arg_types;
	    print STDERR ("\t$return_type $function(", 
			  join(', ', @args), ")\n");
	}
    }
    else {
	print STDERR "No $o->{language} functions have been successfully bound to Perl.\n\n";
    }

    print STDERR <<END;

<-----------------------End of Information Section---------------------------->
END
}

# end of Inline::print_info
1;
